<?php

namespace Litematrimony\Preference\Actions;

use Illuminate\Support\Carbon;
use Illuminate\Support\Str;
use Litepie\Actions\Concerns\AsAction;
use Litepie\Actions\Traits\LogsActions;
use Litepie\Notification\Traits\SendNotification;
use Litematrimony\Preference\Models\Preference;


class PreferenceAction
{
    use AsAction;

    protected $model;
    protected $namespace = 'litematrimony.preference.preference';
    protected $eventClass = \Litematrimony\Preference\Events\PreferenceAction::class;
    protected $action;
    protected $function;
    protected $request;

    public function handle(string $action, Preference $preference, array $request = [])
    {
        $this->action = $action;
        $this->request = $request;
        $this->model = $preference;
        $this->function = Str::camel($action);
        $this->executeAction();
        return $this->model;

    }


    public function store(Preference $preference, array $request)
    {
        $attributes = $request;
        $attributes['user_id'] = user_id();
        $attributes['user_type'] = user_type();
        $preference = $preference->create($attributes);
        return $preference;
    }

    public function update(Preference $preference, array $request)
    {
        $attributes = $request;
        $preference->update($attributes);
        return $preference;
    }

    public function destroy(Preference $preference, array $request)
    {
        $preference->delete();
        return $preference;
    }

    public function copy(Preference $preference, array $request)
    {
        $count = $request['count'] ?: 1;

        if ($count == 1) {
            $preference = $preference->replicate();
            $preference->created_at = Carbon::now();
            $preference->save();
            return $preference;
        }

        for ($i = 1; $i <= $count; $i++) {
            $new = $preference->replicate();
            $new->created_at = Carbon::now();
            $new->save();
        }

        return $preference;
    }


}
